
function diff(x)
## Erzeugt einen Vektor der Lnge length(x)-1,
## der die Differenz zwischen den Werten angibt
	a=2:length(x);
	return x[a]-x[a-1]
endfunction

function tanint(ffunction,a,b,n)
## Berechnet das Integral von ffunction in [a,b]
## nach der Tangentenmethode, das Ergebnis wird als
## n langer Vektor ausgegeben
	h=(b-a)/(2*n);
	xo=h:2*h:2*n*h;
	x=xo+a;
	if isfunction(ffunction);
		s=ffunction(x,args());
	else
		s=expreval(ffunction,x);
	endif;
	integral=2*h*cumsum(s);
	return integral
endfunction

function maxvector(vect)
## Erzeugt einen 1x2 Vektor mit dem Maximalwert
## des Vektors und der zugehrigen Stelle
	xmax=1;ymax=vect(1);
	for i=2 to length(vect);
	if vect(i)>ymax;
		xmax=i;ymax=vect(i);
	endif;
	end;
	ergebnis=[xmax,ymax];
	return ergebnis
endfunction

function minvector(vect)
## Erzeugt einen 1x2 Vektor mit dem Maximalwert
## des Vektors und der zugehrigen Stelle
	xmin=1;ymin=vect(1);
	for i=2 to length(vect);
	if vect(i)<ymin;
		xmin=i;ymin=vect(i);
	endif;
	end;
	ergebnis=[xmin,ymin];
	return ergebnis
endfunction

function crossborder(vect,grenze)
## Erzeugt einen Nx1 Vektor mit den Stellen, 
## wo die Grenze passiert wird oder Null
	ergebnis=0;
	if vect(1)<grenze; status=-1; endif;
	if vect(1)>=grenze; status=1; endif;
	for i=2 to length(vect);
		if vect(i)<=grenze;
			if status~=1; 
				if ergebnis~=0; ergebnis=i; 
				else; ergebnis=[ergebnis|i];
				endif;
				status=-1; 
			endif;
		elseif vect(i)>=grenze;
			if status~=-1; 
				if ergebnis~=0; ergebnis=i;
				else; ergebnis=[ergebnis|i]; 
				endif;
				status=1; 
			endif;
		endif;
	end;
	return ergebnis
endfunction

function singrad(x)
## Berechnet die Sinusfunktion eines Winkels in Grad
	return sin(x*2*pi/360)
endfunction

function cosgrad(x)
## Berechnet die Cosinusfunktion eines Winkels in Grad
	return cos(x*2*pi/360)
endfunction

function tangrad(x)
## Berechnet die Tangensfunktion eines Winkels in Grad
	return tan(x*2*pi/360)
endfunction

function asingrad(x)
## Berechnet den Winkel in Grad einer Sinusfunktion
	return asin(x)*360/(2*pi)
endfunction

function acosgrad(x)
## Berechnet den Winkel in Grad einer Cosinusfunktion
	return acos(x)*360/(2*pi)
endfunction

function atangrad(x)
## Berechnet den Winkel in Grad einer Tangensfunktion
	return atan(x)*360/(2*pi)
endfunction

function schnitt(vect,x)
## Krzt den Vektor auf x Stellen (oder redim verwenden)
	vectn=(dup(0,x))';
	for i=1 to x;
		vectn(i)=vect(i);
	end;
	return vectn
endfunction

function xplot2(x,y,z)
## Plottet x und y im ersten Quadranten mit Hhenfaktor z
	a=crossborder(y,0);
	yneu=schnitt(y,a);
	xneu=schnitt(x,a);
	setplot(0,max(xneu),0,(max(xneu)*z));xplot(xneu,yneu)
	return {a};
endfunction
